Type primitives
 Field mesh
End Type

Function CamMove()
 mmx# = -MouseXSpeed() / 3.0
 mmy# = MouseYSpeed() / 3.0
 RotateEntity cam, EntityPitch(cam) + mmy, EntityYaw(cam) + mmx, 0
 MoveMouse 400,300
 If KeyDown(17) Then MoveEntity cam,0,0,.1
 If KeyDown(31) Then MoveEntity cam,0,0,-0.1
 If KeyDown(30) Then MoveEntity cam,-.1,0,0
 If KeyDown(32) Then MoveEntity cam,.1,0,0  
End Function 

Function LoadSkyBox()
 m=CreateMesh()
 ;front face
 b=LoadBrush("s2.png",49 )
 s=CreateSurface( m,b )
 AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
 AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;right face	
 b=LoadBrush("s3.png",49 )
 s=CreateSurface( m,b )
 AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
 AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;back face
 b=LoadBrush("s4.png",49 )
 s=CreateSurface( m,b )
 AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
 AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;Left face
 b=LoadBrush("s5.png",49 )
 s=CreateSurface( m,b )
 AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
 AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ;top face
 b=LoadBrush("s1.png",49 )
 s=CreateSurface( m,b )
 AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
 AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
 AddTriangle s,0,1,2:AddTriangle s,0,2,3
 FreeBrush b
 ScaleMesh m,500,500,500
 FlipMesh m
 EntityFX m,1
 Return m 
End Function

Function createprimitives(i = 10)

  For n = 1To i
   w.primitives = New primitives
    r = Rand(1,4)
     If r = 1 Then w\mesh = CreateCube()
     If r = 2 Then w\mesh = CreateCylinder()
     If r = 3 Then w\mesh = CreateCone()
     If r = 4 Then w\mesh = CreateSphere()

     ScaleMesh w\mesh,.5,.5,.5

     EntityColor w\mesh,Rand(1,255),Rand(1,255),Rand(1,255)

     PositionEntity w\mesh,  Rand(-20,20), 1, Rand(-20,20)
  Next
End Function 

Function updprim()
 For w.primitives = Each primitives
  TurnEntity w\mesh,1,1,1
 Next
End Function 

Graphics3D 0,0,0,1
SetBuffer BackBuffer()
AntiAlias True 

HWMultiTex True 

Const MIRROR_RESOLUTION = 256

Global cam = CreateCamera()
 PositionEntity cam,3,5,3

Global camcube = CreateSphere(20,cam)
 ScaleMesh camcube,.5,.5,.5
 EntityTexture camcube,LoadTexture("svib.jpg")
  
 TurnEntity camcube,0,180,0

sphere = CreateSphere(30)
 PositionEntity sphere,0,2,0
 EntityFX sphere,1
 ;EntityTexture sphere,LoadTexture("ball.png",2),0,1
plane = CreatePlane()
 EntityTexture plane, LoadTexture("grass.jpg")

LoadSkyBox()


light = CreateLight()
 PositionEntity light,-100,100,100

Global Scam = CreateCamera()
 CameraViewport scam,0,0,MIRROR_RESOLUTION,MIRROR_RESOLUTION
 PositionEntity scam,0,2,0
 
Global mirt = CreateTexture(MIRROR_RESOLUTION,MIRROR_RESOLUTION,64)
 EntityTexture sphere,mirt,0,0
 createprimitives(20)

While Not KeyHit(1)
 CamMove()
  updprim()

  
 UpdateWorld 

 CameraProjMode scam,1
 CameraProjMode cam,0

 ;RotateEntity scam, -EntityPitch(cam), - EntityYaw(cam), - EntityRoll(cam)
 PointEntity scam,cam
 

 RenderWorld


 CopyRect 0,0,MIRROR_RESOLUTION,MIRROR_RESOLUTION,0,0,BackBuffer,TextureBuffer(mirt)

 UpdateWorld

 CameraProjMode scam,0
 CameraProjMode cam,1
 
 UpdateWorld 


 RenderWorld
 Flip
 Delay(10)
Wend

End